VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ExampleClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "This class illustrates how to use properties and methods"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

'When we have class properties, the convention is to create
'a local variable that actually holds the property values.
'These are usually prefixed by 'mvar' (member variable)
'to indicate that these are local

'local variable(s) to hold property value(s)
Private mvarValue As Integer 'local copy

'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent Ouch(Message)
Public Event Ouch(Message As String)
Attribute Ouch.VB_Description = "Whenever this event is raised we say ouch"

'Let functions let us do things like object.Value = 5
Public Property Let Value(ByVal vData As Integer)
Attribute Value.VB_Description = "A value that is altered by a method"
    mvarValue = vData
    If mvarValue > 20 Then RaiseEvent Ouch("I'm bigger than 20")
End Property
'Get functions let us do things like X = object.Value
Public Property Get Value() As Integer
    Value = mvarValue
End Property
'This is a method which has an optional argument
Public Sub Increment(Optional Amount As Integer = 1)
Attribute Increment.VB_Description = "Increments a value"
    Me.Value = Me.Value + Amount
End Sub
'This routine is called automatically whenever the object is created
'When an object is created, initialize any values and
'display a message
Private Sub Class_Initialize()
    Me.Value = 0
    MsgBox "In Class_Initialize, value is " & Me.Value
End Sub
'This routine is called automatically whenever the object is destroyed
'When the object is destroyed, display a message saying so.
Private Sub Class_Terminate()
    MsgBox "In Class_Terminate, value is " & Me.Value
End Sub
